
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>UIViewController 的生命周期 &amp; iOS程序的启动顺序 / 憋错料</title>

    <meta name="description" content="UIViewController 的生命周期 &amp; iOS程序的启动顺序 当一个视图控制器被创建,并在屏幕上显示的时候. 代码的执行顺序 1. alloc                                   创建对象,分配空间 2.init (initWithNibName) 初始化对象,初始化数据 3.loadView                          从nib载入视图 ,通常这一步不需要去干涉.除非你没有使用xib文件创建视图 4.viewDidLoad                   载入完成,可以进行自定义数据以及动态创建其">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">UIViewController 的生命周期 &amp; iOS程序的启动顺序</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>当一个视图控制器被创建，并在屏幕上显示的时候。 代码的执行顺序<br />
1、 alloc &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 创建对象，分配空间<br />
2、init (initWithNibName) 初始化对象，初始化数据<br />
3、loadView &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;从nib载入视图 ，通常这一步不需要去干涉。除非你没有使用xib文件创建视图<br />
4、viewDidLoad &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 载入完成，可以进行自定义数据以及动态创建其他控件<br />
5、viewWillAppear &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;视图将出现在屏幕之前，马上这个视图就会被展现在屏幕上了<br />
6、viewDidAppear &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 视图已在屏幕上渲染完成</p>
<p>当一个视图被移除屏幕并且销毁的时候的执行顺序，这个顺序差不多和上面的相反<br />
1、viewWillDisappear &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;视图将被从屏幕上移除之前执行<br />
2、viewDidDisappear &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 视图已经被从屏幕上移除，用户看不到这个视图了<br />
3、dealloc &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 视图被销毁，此处需要对你在init和viewDidLoad中创建的对象进行释放</p>
<p>关于viewDidUnload ：在发生内存警告的时候如果本视图不是当前屏幕上正在显示的视图的话，<br />
viewDidUnload将会被执行，本视图的所有子视图将被销毁，以释放内存,此时开发者需要手动对viewLoad、viewDidLoad中创建<br />
的对象释放内存。 因为当这个视图再次显示在屏幕上的时候，viewLoad、viewDidLoad&nbsp;再次被调用，以便再次构造视图。</p>
<p>当我们创建一个UIViewController类的对象时，通常系统会生成几个默认的方法，这些方法大多与视图的调用有关，但是在视图调用时，这些方法的调用顺序如何，需要整理下。</p>
<p>通常上述方法包括如下几种，这些方法都是UIViewController类的方法：</p>
<p>- (void)viewDidLoad；</p>
<p>- (void)viewDidUnload；</p>
<p>- (void)viewWillAppear:(BOOL)animated；</p>
<p>- (void)viewDidAppear:(BOOL)animated；</p>
<p>- (void)viewWillDisappear:(BOOL)animated；</p>
<p>- (void)viewDidDisappear:(BOOL)animated；</p>
<p>下面介绍下APP在运行时的调用顺序。</p>
<p>1）- (void)viewDidLoad；</p>
<p>一个APP在载入时会先通过调用loadView方法或者载入IB中创建的初始界面的方法，将视图载入到内存中。然后会调用viewDidLoad方法来进行进一步的设置。通常，我们对于各种初始数据的载入，初始设定等很多内容，都会在这个方法中实现，所以这个方法是一个很常用，很重要的方法。</p>
<p>但是要注意，这个方法只会在APP刚开始加载的时候调用一次，以后都不会再调用它了，所以只能用来做初始设置。</p>
<p>2) - (void)viewDidUnload;</p>
<p>在内存足够的情况下，软件的视图通常会一直保存在内存中，但是如果内存不够，一些没有正在显示的viewcontroller就会收到内存不够的警告，然<br />
后就会释放自己拥有的视图，以达到释放内存的目的。但是系统只会释放内存，并不会释放对象的所有权，所以通常我们需要在这里将不需要在内存中保留的对象释<br />
放所有权，也就是将其指针置为nil。</p>
<p>这个方法通常并不会在视图变换的时候被调用，而只会在系统退出或者收到内存警告的时候才会被调用。但是由于我们需要保证在收到内存警告的时候能够对其作出反应，所以这个方法通常我们都需要去实现。</p>
<p>另外，即使在设备上按了Home键之后，系统也不一定会调用这个方法，因为IOS4之后，系统允许将APP在后台挂起，并将其继续滞留在内存中，因此，viewcontroller并不会调用这个方法来清除内存。</p>
<p>3）- (void)viewWillAppear:(BOOL)animated;</p>
<p>系统在载入所有数据后，将会在屏幕上显示视图，这时会先调用这个方法。通常我们会利用这个方法，对即将显示的视图做进一步的设置。例如，我们可以利用这个方法来设置设备不同方向时该如何显示。</p>
<p>另外一方面，当APP有多个视图时，在视图间切换时，并不会再次载入viewDidLoad方法，所以如果在调入视图时，需要对数据做更新，就只能在这个方法内实现了。所以这个方法也非常常用。</p>
<p>4) - (void)viewDidAppear:(BOOL)animated；</p>
<p>有时候，由于一些特殊的原因，我们不能在viewWillApper方法里，对视图进行更新。那么可以重写这个方法，在这里对正在显示的视图进行进一步的设置。</p>
<p>5) - (void)viewWillDisappear:(BOOL)animated；</p>
<p>在视图变换时，当前视图在即将被移除、或者被覆盖时，会调用这个方法进行一些善后的处理和设置。</p>
<p>由于在IOS4之后，系统允许将APP在后台挂起，所以在按了Home键之后，系统并不会调用这个方法，因为就这个APP本身而言，APP显示的view，仍是挂起时候的view，所以并不会调用这个方法。</p>
<p>6) - (void)viewDidDisappear:(BOOL)animated；</p>
<p>我们可以重写这个方法，对已经消失，或者被覆盖，或者已经隐藏了的视图做一些其他操作。</p>
<p>上述方法的流程图可以简单用如下表示：</p>
<p>运行APP &mdash;&gt; 载入视图 &mdash;&gt; 调用viewDidLoad方法 &mdash;&gt; 调用viewWillAppear方法 &mdash;&gt; 调用viewDidAppear方法&nbsp;&mdash;&gt;&nbsp;&nbsp; 正常运行</p>
<p>aaaaaaaa</p>
<p>A&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|</p>
<p>aaaaaaaa&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br />
 &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp; |</p>
<p>aaaaaaaa&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|&nbsp;载<br />
入新的View&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; |</p>
<p>aaaaaaaa&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br />
 &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; |</p>
<p>aaaaaaaa&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br />
 &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;V</p>
<p>释放对象所有权&nbsp;&lt;&mdash;&nbsp;调用viewDidUnload&nbsp;&lt;&mdash; 收到内存警告&nbsp;&lt;&mdash;&nbsp;调用viewDidDisappear&nbsp;&lt;&mdash;&nbsp;调用viewWillDisappear&nbsp;&lt;&mdash;&nbsp; APP需要调用另一个view</p>
<p>IOS程序启动执行顺序</p>
<p><a href="http://www.yifeiyang.net/iphone-developer-advanced-3-iphone-application-startup-process/" rel="external nofollow noreferrer">http://www.yifeiyang.net/iphone-developer-advanced-3-iphone-application-startup-process/</a></p>


<h2>IOS&nbsp;开发&nbsp;loadView&nbsp;和&nbsp;viewDidLoad&nbsp;的区别</h2>
<p>iPhone开发必不可少的要用到这两个方法。 他们都可以用来在视图载入的时候，初始化一些内容。 但是他们有什么区别呢？</p>
<p>viewDidLoad 此方法只有当view从nib文件初始化的时候才被调用。</p>
<p>loadView 此方法在控制器的view为nil的时候被调用。 此方法用于以编程的方式创建view的时候用到。 如：</p>
<ol>
<li>&nbsp;</li>
<li>- ( void ) loadView {</li>
<li>&nbsp; &nbsp; UIView *view = [ [ UIView alloc] initWithFrame:[ UIScreen</li>
<li>mainScreen] .applicationFrame] ;</li>
<li>&nbsp; &nbsp; [ view setBackgroundColor:_color] ;</li>
<li>&nbsp; &nbsp; self.view = view;</li>
<li>&nbsp; &nbsp; [ view release] ;</li>
<li>}</li>
<li>&nbsp;</li>
</ol>
<p>你在控制器中实现了loadView方法，那么你可能会在应用运行的某个时候被内存管理控制调用。 如果设备内存不足的时候， view<br />
控制器会收到didReceiveMemoryWarning的消息。<br />
默认的实现是检查当前控制器的view是否在使用。如果它的view不在当前正在使用的view<br />
hierarchy里面，且你的控制器实现了loadView方法，那么这个view将被release,<br />
loadView方法将被再次调用来创建一个新的view。</p>
<p>--------------------------------------------------------------------------------------------------------------------------------------------</p>
<p><strong>Don‘t read self.view in -loadView.</strong> Only <em>set</em> it, don‘t<br />
<em>get</em> it.</p>
<p>The self.view property accessor <em>calls</em> -loadView if the view isn‘t currently loaded. There‘s your infinite recursion.</p>
<p>The usual way to build the view programmatically in -loadView, as<br />
demonstrated in Apple‘s pre-Interface-Builder examples, is more like<br />
this:</p>
<pre><code>UIView   * view  =   [[ UIView alloc ] init ...];
 ...
 [ view addSubview : whatever ];
 [ view addSubview : whatever2 ];
 ...
 self . view  = view ;
 [ view release ];
 </code> </pre>
<p>And I don‘t blame you for not using IB. I‘ve stuck with this method for all of Instapaper and find myself much more comfortable with it than dealing with IB‘s complexities, interface quirks, and unexpected behind-the-scenes behavior.</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-10 04:45:57 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>UIViewController 的生命周期 &amp; iOS程序的启动顺序的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jL2oD4.html" rel="bookmark">iOS程序执行顺序 AppDelegate及 UIViewController 的生命周期</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS程序的启动执行顺序 AppDelegate 及 UIViewController 的生命周期 iOS应用程序的状态切换很重要,而UIViewControler对于iOS这种MVC模式来说尤为重要,基本都要继承自他. 一.iOS程序的启动执行顺序 1 程序的入口 进入main函数, 设置AppDelegate称为函数的代理 2  程序完成加载 -[AppDelegate application:didFinishLaunchingWithOptions:] 3 创建window窗口 4 程序			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/BMzbJMk.html" rel="bookmark">iOS程序执行顺序和UIViewController 的生命周期&lpar;整理&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				说明:此文是自己的总结笔记,主要参考: iOS程序的启动执行顺序 AppDelegate 及 UIViewController 的生命周期 UIView的生命周期 言叶之庭.jpeg 一. iOS程序的启动执行顺序 程序启动顺序图 iOS启动原理图.png 具体执行流程 程序入口进入main函数,设置AppDelegate称为函数的代理 程序完成加载[AppDelegate application:didFinishLaunchingWithOptions:] 创建window窗口 程序被激活[			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6DLeG3.html" rel="bookmark">Info&period;plist和pch文件的作用，UIApplication，iOS程序的启动过程，AppDelegate 方法解释，UIWindow，生命周期方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自:http://blog.csdn.net/dwt1220/article/details/29373817 Info.plist常见的设置 建立一个工程后,会在Supporting files文件夹下看到一个“工程名-Info.plist”的文件,该文件对工程做一些运行期的配置,非常重要,不能删除  注:在旧版本Xcode创建的工程中,这个配置文件的名字就叫“Info.plist”  项目中其他Plist文件不能带有“Info”这个字眼,不然会被错认为是传说中非常重要的“Info.plis			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgEyWn3.html" rel="bookmark">iOS程序的执行顺序  和  UIViewController的生命周期</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS程序的执行顺序 1 进入程序的入口 进入main函数, 设置AppDelegate称为函数的代理 2  程序完成加载 -[AppDelegate application:didFinishLaunchingWithOptions:] 3 创建window窗口 4 程序被激活 -[AppDelegate applicationDidBecomeActive:] 5 当点击command+H时  程序取消激活状态 -[AppDelegate applicationWillResignActiv			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoexOk3.html" rel="bookmark">【iOS】UIViewController的生命周期</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				UIViewController中存在的2个循环: 在UIViewController中,View存在两个循环:加载循环和卸载循环. 加载循环 1&gt;程序请求controller的view. 2&gt;如果view在内存中,则直接加载.相反,如果不存在,则UIViewController调用loadView方法. 3&gt;loadView方法执行如下操作: 如果你重载了这个方法,则必须创建必要的view并且将一个非nil值传给UIViewController的view属性. 如果你没有重载这个函数,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLJgoE3.html" rel="bookmark">UIViewController的生命周期</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS基础界面就是通过UIViewController展示的.首先区分content controller和container controller的区别.content controlller就是展示我们当前页面的controller,而container controller就是一个管理content controller的容器,基本就是UINavigationController和UITabbarController,本身它也是继承UIViewController,一个UIViewCont			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWjpWL4.html" rel="bookmark">iOS程序的执行顺序和iOS程序文件执行顺序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS程序的执行顺序 首先从main.m文件的main函数开始执行的.int main(int argc, char * argv[]) { @autoreleasepool { return UIApplicationMain(argc, argv, nil, NSStringFromClass([AppDelegate class])); } } //1.principalClassName:应用程序对象的类名(UIApplication或其子类) //2.delegateClassName			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3r57e90.html" rel="bookmark">UIViewController的生命周期及iOS程序执行顺序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				当一个视图控制器被创建,并在屏幕上显示的时候. 代码的执行顺序1. alloc                                   创建对象,分配空间2.init (initWithNibName) 初始化对象,初始化数据3.loadView                          从nib载入视图 ,通常这一步不需要去干涉.除非你没有使用xib文件创建视图4.viewDidLoad                   载入完成,可以进行自定义数据以及动态创建其他控件5			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MV7Xaz0.html" rel="bookmark">UIViewController的生命周期及方法调用顺序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ViewController解析 UIViewController是iOS顶层视图的载体及控制器,用户与程序界面的交互都是由UIViewController来控制的,UIViewController管理UIView的生命周期及资源的加载与释放. UIView与UIWindow共同展示了应用程序的用户界面.可以将UIView理解成画布,UIWindow理解成画框.这两个类的继承关系是这样的: NSObject — UIResponder — UIView — UIWindow  (UIWindow			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/v0kGDj0.html" rel="bookmark" class="title">matplotlib刻度设置详解</a>
					<div>
						今天给大家总结一下matplotlib绘图时如何设置刻度,希望对正在学习matplotlib的同学有帮助. Tick locating and formatting 该模块包括许多类以支持完整的刻度位 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Z0YqVr0.html" rel="bookmark" class="title">NYOJ306 走迷宫&lpar;dfs&plus;二分搜索&rpar;</a>
					<div>
						题目描述 http://acm.nyist.net/JudgeOnline/problem.php?pid=306 Dr.Kong设计的机器人卡多非常爱玩,它常常偷偷跑出实验室,在某个游乐场玩之不疲. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/bMoZok4.html" rel="bookmark" class="title">1101&colon; 零起点学算法08&mdash;&mdash;简单的输入和计算（a&plus;b&rpar;</a>
					<div>
						1101: 零起点学算法08--简单的输入和计算(a+b) Time Limit: 1 Sec  Memory Limit: 128 MB   64bit IO Format: %lldSubmitt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDRvao3.html" rel="bookmark" class="title">layoutsubviews</a>
					<div>
						layoutSubviews在以下情况下会被调用: 1.init初始化不会触发layoutSubviews 2.addSubview会触发layoutSubviews 3.设置view的Frame会触 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmlNXQ4.html" rel="bookmark" class="title">Linux虚拟内存相关知识</a>
					<div>
						Linux 的虚拟内存管理有几个关键概念: 1.每个进程都有独立的虚拟地址空间,进程访问的虚拟地址并不是真正的物理地址: 2.虚拟地址可通过每个进程上的页表(在每个进程的内核虚拟地址空间)与物理地址进 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35lLJv0.html" rel="bookmark" class="title">学习笔记（C&plus;&plus;Primer）--易错点总结（Chapter2）</a>
					<div>
						2.1.2Type Conversions(1/10/2017) 1.If we assign an out-of-range value to an object of unsigned type, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWYXzm3.html" rel="bookmark" class="title">&commat;酱油--路慢慢其修远兮</a>
					<div>
						一,我与酱油的差异 1,酱油用利润在玩股票,我是用本金在玩股票 2,酱油被套了,不补仓不割肉,我会割肉会补仓 3,酱油基本不换股,我会换股 4,酱油只买小盘股,我会买大盘股创业板 5,酱油跌了一般心不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38Ld9K3.html" rel="bookmark" class="title">《用格式化&lpar;fprintf和fscanf函数&rpar;的方式读写文件》</a>
					<div>
						//用格式化(fprintf和fscanf函数)的方式读写文件 [用格式化的方式向文件中写入数据]#include&lt;stdio.h&gt;#include&lt;stdlib.h&gt; int ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xr8vL4.html" rel="bookmark" class="title">201412020654-hd-回文数猜想</a>
					<div>
						回文数猜想 Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Subm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoxmlD0.html" rel="bookmark" class="title">备份文件</a>
					<div>
						学习OS模块: #!/usr/bin/python import os import time import socket def getsource(): print &quot;[Info]-Pl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xr28k4.html" rel="bookmark" class="title">KB-2</a>
					<div>
						四:修改网页模式 //UIWebView是一个网页浏览器 可以加载网页也可以加载一些本地文件, 如pdf,txt,html //-------------------------首先加载荣誉网页--- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgZXkN4.html" rel="bookmark" class="title">LNMP新版安装</a>
					<div>
						LNMP环境 首先安装nginx,nginx已完成 第二安装mysql [[email protected] mnt]# tar zxf mysql-5.5.38.tar.gz  -C /usr/sr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35Awy13.html" rel="bookmark" class="title">mysql 索引&lpar; mysql index &rpar;</a>
					<div>
						来源:http://blog.csdn.net/luketty/article/details/5772429 索引 mysql index 索引是一种数据结构,可以是B-tree, R-tree,  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pPlxK4.html" rel="bookmark" class="title">关键字-transient</a>
					<div>
						一个对象实现了Serilizable接口,就可以被序列化:  如果某个属性不想被序列化则使用transient关键字 用户有一些敏感信息(如密码,银行卡号等),为了安全起见,不希望在网络操作(主要涉及 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoLmWQ0.html" rel="bookmark" class="title">dedecms（织梦）在后台新建新的模型时 ，点击编辑的时候 更新时间不能弹出</a>
					<div>
						dedecms(织梦)在后台新建新的模型时 ,点击编辑的时候 更新时间不能弹出 ,分析了一下代码发现htm文件少了个js代码,其实很简单,我想dede官方也不会想到自己会写错. 解决办法 后台栏目默认 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3waaDVM.html" rel="bookmark" class="title">Sort Anagrams</a>
					<div>
						cc150 Question 11.2 Sort array of string that anagrams next to each other. (leetcode 也有类似题目) Solutio ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eEjEJ0.html" rel="bookmark" class="title">LeetCode 51 N-Queens II</a>
					<div>
						Follow up for N-Queens problem. Now, instead outputting board configurations, return the total numbe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0b59XvM.html" rel="bookmark" class="title">linux&lowbar;文件压缩以及归档</a>
					<div>
						压缩以及解压缩:  压缩格式: gz,bz2,xz,zip,z 压缩算法:压缩算法不同,压缩比也会不同,压缩算法在此不做讨论    对文件的压缩以及解压缩    gzip: *.gz       gz ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pNj9g0.html" rel="bookmark" class="title">javascript 中的面向对象实现 如何封装</a>
					<div>
						面向对象的手法来封装javascript ,javascript是没有类的概念的. 所以今天谈到的封装,其实就是用javascript的函数来实现的. 1 2 3 4 var People{ name ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzkaNO0.html" rel="bookmark" class="title">HDU5056 BoringCount--线性扫一遍</a>
					<div>
						11754936 2014-09-29 10:08:45 Accepted 5056 31MS 392K 1257 B G++ czy 好简单的思路,怎么就没想到呢..... Boring count ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
